program cbm64w;

{
  CBM64 Emulator by Paul TOTH <tothpaul@free.fr> - Windows 32 bits version
  http://tothpaul.free.fr/cbm64.php3

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

uses
  Windows,
  sysutils,
  Messages,
  resource in 'resource.pas',
  c64 in 'c64.pas',
  vic in 'vic.pas',
  cia in 'cia.pas'; // no VCL :)

{$R *.RES  for MainIcon}

Var
  Msg:TMsg;
  scrWidth,scrHeight:integer;
  frmWidth,frmHeight:integer;
  winHeight:integer;
  Scale1,Scale2:integer;
  Left,Top,Width,Height:integer;

Function WinProc(hWnd: THandle; Msg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
 begin
  Result:=0;
  Case Msg of
   WM_GETMINMAXINFO: begin
    with PMinMaxInfo(lparam)^ do begin
     ptMaxSize.x:=360*Scale2+2*FrmWidth;
     ptMaxSize.y:=240*Scale2+2*FrmHeight+winHeight;
     ptMaxPosition.x:=(scrwidth-ptMaxSize.x) div 2;
     ptMaxPosition.y:=(scrHeight-ptMaxSize.y) div 2;
    end;
   end;
   WM_SIZE   : begin
                ScreenWidth :=(lParam and $ffff);
                ScreenHeight:=(lParam shr 16);
                SetWindowText(hWnd,pchar(Title+Format(' [%dx%d]',[ScreenWidth,ScreenHeight])));
               end;
   WM_PAINT   : begin
                 CBM64.VIC.DrawDIB;
                 Result:=(DefWindowProc(hWnd, msg, wParam, lParam));
                end;
   WM_KEYDOWN : Keybuffer:=Keybuffer+Char(wParam);
//   WM_KEYUP   : Keybuffer:=Keybuffer+Char(wParam+128);
   WM_DESTROY : PostQuitMessage(0);
   else Result:=(DefWindowProc(hWnd, msg, wParam, lParam));
  end;
 end;

Procedure RegisterMe;
 var
  wc:TWndClass;
 begin
 { Register the window class for my window. }
  wc.style :=  0; // CS_SAVEBITS;            { Class style. }
  wc.lpfnWndProc := @WinProc;          { Window procedure for this class. }
  wc.cbClsExtra := 0;                  { No per-class extra data. }
  wc.cbWndExtra := 0;                  { No per-window extra data. }
  wc.hInstance := hInstance;           { Application that owns the class. }
  wc.hIcon := LoadIcon(hInstance,'MAINICON');  { Delphi icon }
  wc.hCursor := LoadCursor(0, IDC_ARROW); { defaut cursor }
  wc.hbrBackground := 0; // GetStockObject(BLACK_BRUSH); { black screen }
  wc.lpszMenuName := nil; // 'MainMenu';       { Name of menu resource in .RC file. }
  wc.lpszClassName := ClassName;      { Name used in call to CreateWindow. }
  if RegisterClass(wc)=0 then begin
   Messagebox(0,RegisterError,Title,MB_ICONERROR);
   Halt;
  end;
 end;

Procedure CreateMe;
 begin
{ Create a main window  }
 scrWidth :=GetSystemMetrics(SM_CXFULLSCREEN);    // 800
 frmWidth :=GetSystemMetrics(SM_CXFRAME);         // 4
 scrHeight:=GetSystemMetrics(SM_CYFULLSCREEN);    // 553 = 600-47 (w95 menubar)
 frmHeight:=GetSystemMetrics(SM_CYFRAME);         // 4
 winHeight:=GetSystemMetrics(SM_CYCAPTION);       // 19

 Scale1:=scrWidth div 360;
 Scale2:=scrHeight div 240;
 if Scale1<Scale2 then Scale2:=Scale1;
 Scale1:=1;

 Width :=360*Scale1+2*FrmWidth;
 Height:=240*Scale1+2*FrmHeight+winHeight;
 Top:=(scrHeight-Height) div 2;
 Left:=(scrwidth-Width) div 2;

 hWnd := CreateWindow(
  ClassName,  { registered class name }
  Title,
  WS_OVERLAPPEDWINDOW or ws_visible,   { Window style. }
  Left, // cw_usedefault,         { Default horizontal position. }
  Top, // cw_usedefault,         { Default vertical position. }
  Width,//  360+8, //cw_usedefault,         { Default width. }
  Height, //240+27, //cw_usedefault,         { Default height. }
  0,                     { Overlapped windows have no parent. }
  0,                     { Use the window class menu. }
  hInstance,             { This instance owns this window. }
  nil                    { Pointer not needed. }
 );
 if HWnd=0 then begin
  MessageBox(0,WindowError,Title,MB_ICONERROR);
  halt;
 end;
end;

begin
{$IFDEF DEBUG}AllocConsole;{$ENDIF}
 RegisterMe; // Halt on error
 Try // try finally to release resources
  try  // try except to allow Delphi IDE to catch exception...
   CBM64:=TC64.Create; // create VIC, CIAs ...
   CreateMe; // Create Main Window, set hWnd
   Repeat
    CBM64.EmulateLine;
    if PeekMessage(Msg,0,0,0,pm_remove) then begin
     TranslateMessage(msg);    { Translates virtual key codes. }
     DispatchMessage(msg);     { Dispatches message to window. }
    end;
   Until Msg.Message=WM_QUIT;
  except
   on e:Exception do MessageBox(0,pchar(e.message),Title,0);
  end;
 Finally
  CBM64.Free;
 end;
 {$IFDEF DEBUG}FreeConsole;{$ENDIF}
end.
