unit resource;

interface

uses windows;

{$R RESOURCE.RES}

Const
 Title='CBM64 Emulator';
 ClassName='TCBM64W1';
// Error messages
 RegisterError='Unable to register main window';
 WindowError='Unable to create main window';
 ResNotFoundError='Unable to found resource ';
 ResNotLoadError='Unadle to load resource ';
 JamError='Processor JAM !'#13#10'Reset emulator ?';
//---------------------
 KEYS:array[1..127] of word=(
 {   1    2    3    4    5    6    7   <-    9   10}
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$000,$0FF,$0FF,
 {  11   12   RT   14   15  16=S  17   18   19   20}
  $0FF,$0FF,$001,$0FF,$0FF,$00F,$00F,$00F,$0FF,$0FF,
 {  21   22   23   24   25   26   27   28   29   30}
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$00E,$0FF,$0FF,$0FF,
 {  31  ' '   33   34   35    $   37   38   39   40}
  $0FF,$074,$0FF,$0FF,$0FF,$113,$0FF,$0FF,$0FF,$0FF,
 {  41    *    +    ,    -   46   47    0    1    2}
  $0FF,$061,$050,$057,$053,$0FF,$0FF,$043,$070,$073, { 50 }
 {   3    4    5    6    7    8    9   58   F1   F2}
  $173,$013,$020,$023,$030,$033,$040,$0FF,$004,$104, { 60 }
 {  F3   F4   F5   F6 65=a 66=b 67=c 68=d 69=e 70=f}
  $005,$105,$006,$106,$012,$034,$024,$022,$016,$025, { 70 }
 {71=g 72=h 73=i 74=j 75=k 76=l 77=m 78=n 79=o 80=p}
  $032,$035,$041,$042,$045,$052,$044,$047,$046,$051, { 80 }
 {81=q 82=r 83=s 84=t 85=u 86=v 87=w 88=x 89=y 90=z}
  $076,$021,$015,$026,$036,$037,$011,$027,$031,$014, { 90 }
//                            0    1    2    3    4
  $0FF,$0FF,$0FF,$0FF,$0FF,$043,$070,$073,$010,$013, { 100 }
//   5    6    7    8    9
  $020,$023,$030,$033,$040,$0FF,$0FF,$0FF,$0FF,$0FF,
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF
 );
 SKEY:array[1..127] of word=(
 //  1    2    3    4    5    6    7    8    9   11
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF, { 10 }
  $0FF,$0FF,$0FF,$0FF,$0FF,$00F,$00F,$00F,$0FF,$0FF, { 20 }
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$00E,$0FF,$0FF,$0FF, { 30 }
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF, { 40 }
//                                      0    1    2
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$043,$070,$073, { 50 }
//   3    4    5    6    7    8    9
  $010,$013,$020,$023,$030,$033,$040,$0FF,$004,$104, { 60 }
//                       a    b    c    d    e    f
  $005,$105,$006,$106,$112,$134,$124,$122,$116,$125, { 70 }
//   g    h    i    j    k    l    m    n    o    p
  $132,$135,$141,$142,$145,$152,$144,$147,$146,$151, { 80 }
//   q    r    s    t    u    v    w    x    y    z
  $176,$121,$115,$126,$136,$137,$111,$127,$131,$114, { 90 }
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF, { 100 }
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF, { 110 }
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF, { 120 }
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF
 );
 AKEY:array[1..127] of word=(
 //  1    2    3    4    5    6    7    8    9   10
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF, { 10 }
  $0FF,$0FF,$0FF,$0FF,$0FF,$00F,$00F,$00F,$0FF,$0FF, { 20 }
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$00E,$0FF,$0FF,$0FF, { 30 }
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF, { 40 }
//                                      @    1    2
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$056,$070,$073, { 50 }
//   #         [                   ^
  $110,$00F,$155,$00F,$00F,$00F,$066,$0FF,$004,$104, { 60 }
//                       a    b    c    d    e    f
  $005,$105,$006,$106,$112,$134,$124,$122,$116,$125, { 70 }
//   g    h    i    j    k    l    m    n    o    p
  $132,$135,$141,$142,$145,$152,$144,$147,$146,$151, { 80 }
//   q    r    s    t    u    v    w    x    y    z
  $176,$121,$115,$126,$136,$137,$111,$127,$131,$114, { 90 }

  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF, { 100 }
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF, { 110 }
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF, { 120 }
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF
 );


Var
 hWnd:THandle;
 ScreenWidth,ScreenHeight:integer;
 KeyMatrix:array[0..7] of byte;
 RevMatrix:array[0..7] of byte;
 Keybuffer:string;

Procedure LoadData(Var Data; ResName:string);

implementation

Procedure LoadData(Var Data; ResName:string);
 Var
  HRes:THandle;
  HMem:THandle;
 begin
  HRes:=FindResource(hInstance,pchar(ResName),RT_RCDATA);
  if HRes=0 then begin
   MessageBox(0,pchar(ResNotFoundError+ResName),Title,MB_ICONERROR);
   Halt;
  end;
  HMem:=LoadResource(hInstance,HRes);
  if HMem=0 then begin
   MessageBox(0,pchar(ResNotLoadError+ResName),Title,MB_ICONERROR);
   Halt;
  end;
  Move(LockResource(HMem)^,Data,SizeOfResource(hInstance,HRes));
  UnlockResource(HMem);
  FreeResource(HRes);
 end;

end.
